(* Dumper *)

open Clauses;;

let fp = Printf.fprintf;;

(*** dump_human_readable *)
let dump_human_readable oc variables clauses =
  CS.iter
    begin fun (pos,neg) ->
      IS.iter (fun variable -> fp oc " !%s" (Numbering.name variables variable)) neg;
      IS.iter (fun variable -> fp oc " %s" (Numbering.name variables variable)) pos;
      fp oc "\n"
    end
    clauses
;;
(* ***)
(*** dump_machine_readable *)
let dump_machine_readable oc variables clauses =
  fp oc "p cnf %d %d\n" (Numbering.number variables) (CS.cardinal clauses);
  CS.iter
    begin fun (pos,neg) ->
      IS.iter (fun variable -> fp oc " %d" (- (variable + 1))) neg;
      IS.iter (fun variable -> fp oc " %d" (variable + 1)) pos;
      fp oc " 0\n"
    end
  clauses
;;
(* ***)
(*** dump *)
let dump variables clauses =
  match !Opt.dump_clauses with
  | None -> ()
  | Some fn ->
      let oc = open_out fn in
      if !Opt.cnf then
        dump_machine_readable oc variables clauses
      else
        dump_human_readable oc variables clauses;
        close_out oc
;;
(* ***)
