(* Metric *)

open Debug;;

let load_from_file fn =
  let ic = open_in fn in
  let metrics = ref [] in
  let line = ref 0 in
  try
    while true do
      incr line;
      let l = input_line ic in
      let r = Util.split_at ' ' l in
      match r with
      | [x;y] ->
          let y = float_of_string y in
          metrics := (x,y) :: !metrics
      | _ -> invalid_arg (sf "Metric.load_from_file: In file %S, can't parse line %d" fn !line)
    done;
    assert false
  with
  | End_of_file ->
      close_in ic;
      !metrics
;;
