(* Numbering *)

type 'a t = {
  mutable number : int;
  forward : ('a,int) Hashtbl.t;
  backward : (int,'a) Hashtbl.t
};;
let create ?(m=1024) () =
  { number = 0;
    forward = Hashtbl.create m;
    backward = Hashtbl.create m }
;;
let number numbering = numbering.number;;
let name numbering id = Hashtbl.find numbering.backward id;;
let register numbering entry =
  try
    Hashtbl.find numbering.forward entry
  with
  | Not_found ->
      let id = numbering.number in
      numbering.number <- id + 1;
      Hashtbl.add numbering.forward entry id;
      Hashtbl.add numbering.backward id entry;
      id
;;
let find numbering entry = Hashtbl.find numbering.forward entry;;
